#ifndef _COMM_H_
#define _COMM_H_

#include "global.h"
#include "constants.h"
#include "lattice.h"
#include "node.h"
#include <stdio.h>
#include <stdlib.h>
#include "statistic.h"
#include "statisticEntry.h"
#include "utils.h"

#ifdef MPICOMM
#include "mpi.h"
#endif /*MPICOMM*/

/* MPI or Vanilla exection prototypes */

void initialize(int argc, char* argv[]);

void terminate(int status);

int COMM_Send(void* message, int count, int dest, int tag);

int COMM_Recv(void* message, int count, int source, int tag);

int COMM_Bcast(void* message, int count, int root);

int COMM_Gather(void* sendbuf, int sendcount, void* recvbuf, int recvcount, int root);

int COMM_Allgather(void* sendbuf, int sendcount, void* recvbuf, int recvcount);

int COMM_ReduceSUM(void* operand, void* result, int count, int root);

int COMM_AllreduceSUM(void* operand, void* result, int count);

void distributeInputData();

void COMM_Barrier();

#endif
