#ifndef _CONSTANTS_H_
#define _CONSTANTS_H_

/***********************************/
/************* GENERAL *************/
/***********************************/

/* circle number PI hardcoded */
#define PI 3.14159265358979323846

/* maximum filename for saving an arbitrary file */
#define MAXFILENAME 256

/* macros for binary flag - ON and OFF */
#define ON 1
#define OFF 0

/* macros for the parity */
#define ODD 1
#define EVEN 2

/* macros for obtaining ghost sites */
#define LEFT 0
#define TOP 1
#define UP 2
#define RIGHT 3
#define BOTTOM 4
#define DOWN 5

/* defines the number of CPUs per configuration */
#define BLADE_CPUS 16

/* defines the the globalmaster, latticemaster and all processes for the use in debugPrint */
#define GLOBALM 0
#define LATTICEM 1
#define ALL 2

/***********************************/
/********** FILE SPECIFIC **********/
/***********************************/

/* error codes for the input.c IO functions */
#define INPUT_NO_ERROR 0
#define INPUT_FILE_NOT_FOUND 1
#define INPUT_IO_NO_ACCESS 2
#define INPUT_INV_FILENAME 3

/* shortcuts for binary flags in input.c commandLineParser */
#define SHOW_PROMPT 1
#define HIDE_PROMPT 0

/* codes for load config file in input.c */
#define NO_LOAD_CONFIG 0
#define YES_LOAD_CONFIG 1
#define YES_PROMPT_MODE 2

/* codes for save evaluation file in input.c */
#define NO_SAVE_EVAL 0
#define YES_SAVE_EVAL 1

/* codes for save lattice in input.c */
#define FORGET_LATTICE 0
#define SAVE_LATTICE_DEFAULT 1
#define SAVE_LATTICE_BINARY 2
#define SAVE_LATTICE_TEXT 3

/* codes for load lattice in input.c */
#define CREATE_NEW_LATTICE 0
#define LOAD_LATTICE_BINARY 1
#define LOAD_LATTICE_TEXT 2

/* error codes for the lattice_io.c functions */
#define LATTICE_IO_NO_ERROR 0
#define LATTICE_IO_NOT_FOUND 1
#define LATTICE_IO_NO_ACCESS 2
#define LATTICE_IO_INV_FILENAME 3
#define LATTICE_IO_ERR_HEAD 4
#define LATTICE_IO_WRONG_DIM 5

/* shortcuts for binary flags in lattice_io.c */
#define LATTICE_IO_BINARYMODE 0
#define LATTICE_IO_TEXTMODE 1

/* shortcuts for terminate function */
#define EXIT_OK 0
#define EXIT_MPI 1
#define EXIT_CPU_COUNT 2
#define EXIT_FILE_ERR 3
#define EXIT_CMD_LINE 4

#endif