#ifndef _GLOBAL_H_
#define _GLOBAL_H_

#include "lattice.h"
#include "node.h"
#include "statisticEntry.h"

#ifdef _MAIN_H_
#define EXTERN
#else
#define EXTERN extern
#endif

/* Shows information about the configuration specified by the user */
EXTERN lattice currentConf;

/* Represents a structure with information on this specified node */
EXTERN node thisNode;

/* Knows how many lattices are out there (processCount * latticeCount = tot. number) */
EXTERN int latticeCount;

/* Does know about the number of processes involved in that one lattice */
EXTERN int processCount;

/* Represents the index that is currently used for updating */
EXTERN int updateIndex;

/* Contains information about the current parity used for updating */
EXTERN int updateParity;

/* GlobalMaster only - contains all entries for each (Mu,Beta) pair */
EXTERN statisticEntry *entries;

/* LatticeMater only - contains sum of of all spins */
EXTERN double stat_S;

/* LatticeMater only - contains squared sum of spins */
EXTERN double stat_Ssqu;

/* LatticeMater only - contains sum of all hamiltonians */
EXTERN double stat_H;

/* LatticeMater only - contains squared sum of hamiltonians */
EXTERN double stat_Hsqu;

/* LatticeMater only - contains sum of all Helium 4 particles (spin 1 and -1) */
EXTERN double stat_N4;

#endif