#ifndef _INPUTDATA_H_
#define _INPUTDATA_H_

#include "constants.h"

struct inputData
{
	/* lattice dimensions */
	int nx, ny, nz;
	
	/* random number seed */
	int iseed;
	
	/* number of beta iterations */
	int betasteps;
	
	/* number of mu iterations */
	int musteps;
	
	/* inverse temperature to start with */
	double betastart;
	
	/* inverse temperature to end with */
	double betaend;
	
	/* the start value of the parameter mu */
	double mustart;
	
	/* the end value of the parameter mu */
	double muend;
	
	/* the number of warmup runs that will be performed */
	int warmup;
	
	/* the number of iterations that will be performed */
	int iterations;
	
	/* the number of lattice configurations that will be created */
	int repetitions;
	
	/* determines if a lattice should be loaded */
	int loadlattice;
	
	/* determines if a lattice should be saved */
	int savelattice;
	
	/* determines if a configuration file should be loaded */
	int loadconfig;
	
	/* determines if the statistic values should be saved */
	int saveeval;
	
	/* stores the file name to load the lattice */
	char loadlatticefile[MAXFILENAME];
	
	/* stores the file name to save the lattice */
	char savelatticefile[MAXFILENAME];
	
	/* stores the file name to load the configuration */
	char loadconfigfile[MAXFILENAME];
	
	/* stores the file name to save the evaluation */
	char saveevalfile[MAXFILENAME];
	
	/* stores the value if the user wants to input another configuration */
	int prompt;
	
	/* determines if the statistics should be printed out as well */
	int printstatistics;
};

#endif