#ifndef _NODE_H_
#define _NODE_H_

#include "site.h"
#ifdef MPICOMM
#include "mpi.h"
#endif /*MPICOMM*/  

typedef struct
{
	/* sites */
	site *sites;
	
	/* for parallel: ghost sites from other nodes */
	/* for single: replicated own sites (PBC) */
	site **ghostSites;
	
	/* number of sites on this node */
	int sites_on_node;
	
	/* number of even sites on this node */
	int even_sites_on_node;
	
	/* number of odd sites on this node */
	int odd_sites_on_node;
	
	/* node number of this node in the blade */
	int nodeIndex;

	/* node number of this node in total */
	int globalIndex;
	
	/* number of sites in x dir on this node */
	int sites_on_nx;
	
	/* number of sites in y dir on this node */
	int sites_on_ny;
	
	/* number of sites in z dir on this node */
	int sites_on_nz;
	
	/* x offset coordinate for all sites of this node */
	int offset_x;
	
	/* y offset coordinate for all sites of this node */
	int offset_y;
	
	/* z offset coordinate for all sites of this node */
	int offset_z;
	
	/* parity offset coordinate for all sites of this node */
	int parity;
    
#ifdef MPICOMM
    /* MPI groups for Reduce operations */
    MPI_Comm MPI_COMM_BLADE;
	
    MPI_Comm MPI_COMM_MASTERS;
#endif /*MPICOMM*/ 
    
} node;

#endif