#ifndef _STATISTIC_H_
#define _STATISTIC_H_

#include "site.h"
#include "node.h"
#include "global.h"
#include "constants.h"
#include "inputData.h"
#include "lattice.h"
#include "statisticEntry.h"
#include "update.h"
#include "vector.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "utils.h"

#ifdef MPICOMM
#include "mpi.h"
#endif

void initializeStatistic(int reset);

void updateLatticeStatistic();

void makeGlobalStatistic(int n);

double calculateSi();

double calculateN4i();

double calculateHi(double mu);

int saveStatistic(char *fileName);

void freeStatistic();

#endif