#ifndef _VECTOR_H_
#define _VECTOR_H_

#include "comm.h"
#include "utils.h"
#include <math.h>

#ifdef MPICOMM
#include "mpi.h"
#else
#include <stdio.h>
#endif /*MPICOMM*/

// takes one vector _per process_ and sums them element-wise
void vectorsReduce(double* vec, double* out, int veclenght);        

// takes one vectors _per process_, sums them element-wise and sums over the rseulting vector and the square of the resulting vector
// vec is a vector, sum and sumsq are doubles. call i.e. with vectorsReduceSum(s, &a, &b);
// veclenght is currentConf.data.iterations
void vectorsReduceSum(double* vec, double* sum, double* sumsq);

#endif